// cusb.cpp : CCusbxApp ̃Cve[V DLL ̓o^

#include "stdafx.h"
#include "cusbx.h"
#include "cusb.h"
#include <windows.h>
#include <winioctl.h>

#include "ezusbsys.h"

#include <stdio.h>

/////////////////////////////////////////////////////////////////////////////
//

STDMETHODIMP cusb::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_Icusb,
	};

	for (int i=0;i<sizeof(arr)/sizeof(arr[0]);i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}



STDMETHODIMP cusb::usb_open(int n, long* ph)
{
	// TODO: ̈ʒuɃCvgp̃R[hǉĂ
  char szDevName[256];
 	sprintf(szDevName,"\\\\.\\ezusb-%d",n);
  HANDLE h= CreateFile(szDevName,
		GENERIC_WRITE,
		FILE_SHARE_WRITE,
		NULL,
		OPEN_EXISTING,
		0,
		NULL);
	if(h == INVALID_HANDLE_VALUE)
    {
    setErrmsg(GetLastError(),"usb_open");
    }

 *ph=(long)h;

	return S_OK;
}

void cusb::setErrmsg(DWORD dwErr,const char* msg)
{
	m_dwLastErr = dwErr;
  sprintf(m_szErrmsg,"WIN32 ERR:%x [%s]",dwErr,msg);
}

STDMETHODIMP cusb::usb_close(long h,long* pret)
{
	// TODO: ̈ʒuɃCvgp̃R[hǉĂ

   if(CloseHandle((HANDLE)h))
		 *pret = 0;
	 else
    {
    setErrmsg(GetLastError(),"usb_close");
    *pret = -1;
    }


	return S_OK;
}

STDMETHODIMP cusb::usb_halt(long h,long* pret)
{
	// TODO: ̈ʒuɃCvgp̃R[hǉĂ
	unsigned long nbyte;
	VENDOR_REQUEST_IN vreq;
	BOOL ret = FALSE;
	vreq.bRequest = 0xA0;
	vreq.wValue = 0x7F92;
	vreq.wIndex = 0x00;
	vreq.wLength = 0x01;
	vreq.bData = 1;
	vreq.direction = 0x00;
	ret = DeviceIoControl ((HANDLE)h,
							IOCTL_Ezusb_VENDOR_REQUEST,
							&vreq,
							sizeof(VENDOR_REQUEST_IN),
							NULL,
							0,
							&nbyte,
							NULL);

	if(ret)
		*pret  = 0;
	else
    {
    setErrmsg(GetLastError(),"i8051 halt err.");
    *pret = -1;
    }
	return S_OK;
}


STDMETHODIMP cusb::usb_run(long h,long* pret)
{
	// TODO: ̈ʒuɃCvgp̃R[hǉĂ
	unsigned long nbyte;
	BOOL ret = FALSE;
	VENDOR_REQUEST_IN vreq;

	vreq.bRequest = 0xA0;
	vreq.wValue = 0x7F92;
	vreq.wIndex = 0x00;
	vreq.wLength = 0x01;
	vreq.bData = 0;
	vreq.direction = 0x00;
	ret = DeviceIoControl ((HANDLE)h,
							IOCTL_Ezusb_VENDOR_REQUEST,
							&vreq,
							sizeof(VENDOR_REQUEST_IN),
							NULL,
							0,
							&nbyte,
							NULL);
	if(ret)
		*pret = 0;
   else
		 {
    setErrmsg(GetLastError(),"i8051 run err.");
    *pret = -1;
    }
	return S_OK;
}

STDMETHODIMP cusb::usb_download(long h,VARIANT *parrImage, int len,long* pret)
{
 	// TODO: ̈ʒuɃCvgp̃R[hǉĂ
	if(
		!(parrImage->vt | VT_BYREF) ||
		!(parrImage->vt | VT_ARRAY) ||
		!(parrImage->vt | VT_UI1))
		{
    setErrmsg(0,"Type Must VT_BYREF | VT_ARRAY | VT_UI1");
		return E_INVALIDARG;
		}


	SAFEARRAY*      psa = *parrImage->pparray;
	long lBound=0,uBound=0;
	SafeArrayGetLBound(psa, 1, &lBound);
	SafeArrayGetUBound(psa, 1, &uBound);
	if((uBound - lBound + 1) < len) 
		{
    setErrmsg(0,"len is too long");
		return E_INVALIDARG;
		}

  
  char* pimage=(char*)psa->pvData;



	unsigned long nbyte;
	BOOLEAN ret = FALSE;
	
	ret = DeviceIoControl ((HANDLE)h,
							IOCTL_Ezusb_ANCHOR_DOWNLOAD,
							pimage,
							len,
							NULL,
							0,
							&nbyte,
							NULL);

	if(ret)
		*pret =0;
  else {
    setErrmsg(GetLastError(),"usb dwnload err.");
    *pret = -1;
    }

	return S_OK;
}

STDMETHODIMP cusb::usb_resetpipe(long h,long hPipe,long* pret)
{
	// TODO: ̈ʒuɃCvgp̃R[hǉĂ
	unsigned long nbyte;
	BOOL ret = FALSE;
	
	ret = DeviceIoControl ((HANDLE)h,
							IOCTL_Ezusb_RESETPIPE,
							&hPipe,
							sizeof(ULONG),
							NULL,
							0,
							&nbyte,
							NULL);
	if(ret)
		*pret = 0;
   else {
    setErrmsg(GetLastError(),"usb_resetpipe err.");
    *pret = -1;
    }


	return S_OK;
}


STDMETHODIMP cusb::usb_get_string(long h, int idx, BSTR *pbstrVal)
{
	// TODO: ̈ʒuɃCvgp̃R[hǉĂ
  USES_CONVERSION;

	unsigned long nbyte;
	int i;
	char pvbuf[2+128];
	GET_STRING_DESCRIPTOR_IN sin;
	BOOL ret = FALSE;

	sin.Index=idx;
	sin.LanguageId=27;
	ret = DeviceIoControl ((HANDLE)h,
							IOCTL_Ezusb_GET_STRING_DESCRIPTOR,
							&sin,
							sizeof(GET_STRING_DESCRIPTOR_IN),
							pvbuf,
							sizeof (pvbuf),
							&nbyte,
							NULL);
	if(!ret)
    {
    setErrmsg(GetLastError(),"usb_get_string err.");
    return E_FAIL;
    }
  char *str=new char[pvbuf[0]/2];

	for(i=0;i<pvbuf[0]/2-1;i++){
		str[i]=(char)pvbuf[2+i*2];
	}
	str[i]=0;
  
 CComBSTR cstr=A2W(str);
 delete [] str;

 *pbstrVal = cstr.Detach();

	return S_OK;
}




STDMETHODIMP cusb::usb_bulk_write(long h, int nPipe, VARIANT *parrBuf, int len,long* pret)
{
	// TODO: ̈ʒuɃCvgp̃R[hǉĂ
	if(
		!(parrBuf->vt | VT_BYREF) ||
		!(parrBuf->vt | VT_ARRAY) ||
		!(parrBuf->vt | VT_UI1))
		{
    setErrmsg(0,"Type Must VT_BYREF | VT_ARRAY | VT_UI1");
		return E_INVALIDARG;
		}


	SAFEARRAY*      psa = *parrBuf->pparray;
	long lBound=0,uBound=0;
	SafeArrayGetLBound(psa, 1, &lBound);
	SafeArrayGetUBound(psa, 1, &uBound);
	if((uBound - lBound + 1) < len) 
		{
    setErrmsg(0,"len is too long");
		return E_INVALIDARG;
		}

  
  char* buf=(char*)psa->pvData;






 
 	unsigned long nbyte;
 	int i,l;
 	BOOL ret = FALSE;
 	BULK_TRANSFER_CONTROL bulk_control;
 
 	bulk_control.pipeNum = nPipe;
 	for(i=0;len>0;){
 		if(len>0x8000){
 			l=0x8000;
 		}
 		else{
 			l=len;
 		}
 		ret = DeviceIoControl ((HANDLE)h,
 							IOCTL_EZUSB_BULK_WRITE,
 							&bulk_control,
 							sizeof(BULK_TRANSFER_CONTROL),
 							buf+i,
 							l,
 							&nbyte,
 							NULL);
 
 	  if(!ret)
       {
       setErrmsg(GetLastError(),"usb_bulk_write err.");
       *pret = -1;
			 return S_OK;
       }	
 
 		i+=l;
 		len-=l;
 	}

	*pret = 0;
 
	return S_OK;
}

STDMETHODIMP cusb::usb_bulk_read(long h, int nPipe, VARIANT *parrBuf, int len,long* pret)
{
 	// TODO: ̈ʒuɃCvgp̃R[hǉĂ

       // SAFEARRAY쐬
	if(
		!(parrBuf->vt | VT_BYREF) ||
		!(parrBuf->vt | VT_ARRAY) ||
		!(parrBuf->vt | VT_UI1))
		{
    setErrmsg(0,"Type Must VT_BYREF | VT_ARRAY | VT_UI1");
		return E_INVALIDARG;
		}	

	SAFEARRAYBOUND  saBound[1];
  saBound[0].cElements = len;
  saBound[0].lLbound = 0;    
  SAFEARRAY* psa = ::SafeArrayCreate(VT_UI1, 1, saBound);

   char *buf=0;
   HRESULT hr = ::SafeArrayAccessData(psa, (LPVOID*)&buf);


	unsigned long nbyte;

  int i,l,cnt;
 	BOOL ret = FALSE;
 	BULK_TRANSFER_CONTROL bulk_control;
 
 	bulk_control.pipeNum = nPipe;
 	for(i=cnt=0;len>0;){
 		if(len>0x8000){
 			l=0x8000;
 		}
 		else{
 			l=len;
 		}
 		ret = DeviceIoControl ((HANDLE)h,
 							IOCTL_EZUSB_BULK_READ,
 							&bulk_control,
 							sizeof(BULK_TRANSFER_CONTROL),
 							buf+i,
 							l,
 							&nbyte,
 							NULL);
 	  if(!ret)
       break;

 		i+=l;
 		len-=l;
 		cnt+=nbyte;
 	}


   // SAFEARRAYAbN
   ::SafeArrayUnaccessData(psa);
   *parrBuf->pparray = psa;


 if(ret)
	 *pret = 0;
   {
    setErrmsg(GetLastError(),"usb_bulk_read err.");
    *pret = -1;
    }

 	return S_OK;
}

STDMETHODIMP cusb::getLastError(BSTR *pbstrVal)
{
	// TODO: ̈ʒuɃCvgp̃R[hǉĂ
	USES_CONVERSION;
	CComBSTR cstr = A2W(m_szErrmsg);
	*pbstrVal = cstr.Detach();
	return S_OK;
}

STDMETHODIMP cusb::getLastErrorCode(long *pLastErr)
{
	// TODO: ̈ʒuɃCvgp̃R[hǉĂ
	*pLastErr = m_dwLastErr;
	return S_OK;
}

STDMETHODIMP cusb::load_file(BSTR bstrFileName, VARIANT *parrBuf, int reqlen, int *plen)
{
	// TODO: ̈ʒuɃCvgp̃R[hǉĂ
	USES_CONVERSION;
	FILE* fp=fopen(W2A(bstrFileName),"rb");
	if(0==fp)
		{
    setErrmsg(GetLastError(),"FILE OPEN ERROR");
		*plen=-1;
		return S_OK;
		}

	if(
		!(parrBuf->vt | VT_BYREF) ||
		!(parrBuf->vt | VT_ARRAY) ||
		!(parrBuf->vt | VT_UI1))
		{
    setErrmsg(0,"Type Must VT_BYREF | VT_ARRAY | VT_UI1");
		fclose(fp);
	
		return E_INVALIDARG;
		}

	SAFEARRAYBOUND  saBound[1];
  saBound[0].cElements = reqlen;
  saBound[0].lLbound = 0;    
  SAFEARRAY* psa = ::SafeArrayCreate(VT_UI1, 1, saBound);

   char *buf=0;
   HRESULT hr = ::SafeArrayAccessData(psa, (LPVOID*)&buf);

	 *plen=fread(buf,1,reqlen,fp);

	fclose(fp);


   // SAFEARRAYAbN
   ::SafeArrayUnaccessData(psa);
   *parrBuf->pparray = psa;
	
	


	return S_OK;
}

STDMETHODIMP cusb::save_file(BSTR bstrFileName, VARIANT *parrBuf, int len, int *plen)
{
	// TODO: ̈ʒuɃCvgp̃R[hǉĂ
	USES_CONVERSION;
	FILE* fp=fopen(W2A(bstrFileName),"wb");
	if(0==fp)
		{
    setErrmsg(GetLastError(),"FILE OPEN ERROR");
		*plen=-1;
		return S_OK;
		}

	if(
		!(parrBuf->vt | VT_BYREF) ||
		!(parrBuf->vt | VT_ARRAY) ||
		!(parrBuf->vt | VT_UI1))
		{
    setErrmsg(0,"Type Must VT_BYREF | VT_ARRAY | VT_UI1");
		return E_INVALIDARG;
		}


	SAFEARRAY*      psa = *parrBuf->pparray;
	long lBound=0,uBound=0;
	SafeArrayGetLBound(psa, 1, &lBound);
	SafeArrayGetUBound(psa, 1, &uBound);
	if((uBound - lBound + 1) < len) 
		{
    setErrmsg(0,"len is too long");
		fclose(fp);
		return E_INVALIDARG;
		}

  
  char* buf=(char*)psa->pvData;

	*plen=fwrite(buf,1,len,fp);
	fclose(fp);

	return S_OK;
}
